--  Copyright (2008-2013) Cdric Coussinet (cedric.coussinet@nomoseed.net)
--
--  This program is free software: you can redistribute it and/or modify
--  it under the terms of the GNU Affero General Public License as published
--  by the Free Software Foundation, either version 3 of the License, or
--  (at your option) any later version.
--
--  This program is distributed in the hope that it will be useful,
--  but WITHOUT ANY WARRANTY; without even the implied warranty of
--  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
--  GNU Affero General Public License for more details.

--  You should have received a copy of the GNU Affero General Public License
--  along with this program. If not, see <http://www.gnu.org/licenses/>

with Nomo.Interpreter.Logger;

package body Nomo.Interpreter.Gen_Rules_Directories.Logging is

   procedure Log_Full (This       : in Rules_Directory;
                       Buffer_Ptr : not null access Storages.Full_Rule_Storage) is
      References : Rule_References renames This.References;
   begin
      for I in References'First .. This.Last_Reference loop
         Log_Full (References (I).Reference.all, Buffer_Ptr);
         Logger.Log_Full (Buffer_Ptr);
      end loop;
   end Log_Full;

   procedure Log_Partial (This       : in Rules_Directory;
                          Buffer_Ptr : not null access Storages.Full_Rule_Storage) is
      References : Rule_References renames This.References;
   begin
      for I in References'First .. This.Last_Reference loop
         Log_Partial (References (I).Reference.all, Buffer_Ptr);
         Logger.Log_Partial (Buffer_Ptr);
      end loop;
   end Log_Partial;

end Nomo.Interpreter.Gen_Rules_Directories.Logging;
